// Copyright © Microsoft Corporation. All Rights Reserved.
// Licensed under the MIT License.

namespace InteractiveDataDisplay.WPF
{
    /// <summary>
    /// Specifies axes orientation.
    /// </summary>
    public enum AxisOrientation
    {
        /// <summary>
        /// Axis will be vertical and ticks will be aligned to right.
        /// </summary>
        Left,
        /// <summary>
        /// Axis will be vertical and ticks will be aligned to left.
        /// </summary>
        Right,
        /// <summary>
        /// Axis will be horizontal and ticks will be aligned to bottom.
        /// </summary>
        Top,
        /// <summary>
        /// Axis will be horizontal and ticks will be aligned to top.
        /// </summary>
        Bottom
    }
}

